Bug 772845

Summary: Replace-brick commit-force fails if source brick is offline.
Product: [Community] GlusterFS Reporter: krishnan parthasarathi <kparthas>
Component: glusterdAssignee: krishnan parthasarathi <kparthas>
Status: CLOSED CURRENTRELEASE QA Contact: shylesh <shmohan>
Severity: high Docs Contact:
Priority: high    
Version: mainlineCC: gluster-bugs, nsathyan, sgowda
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Linux   
Whiteboard:
Fixed In Version: glusterfs-3.4.0 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-07-24 13:25:33 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 817967    

Description krishnan parthasarathi 2012-01-10 00:52:07 EST
Description of problem:
Replace-brick command commit-force option is aimed at replacing a 'broken' node which can no longer be used/reached. But we fail replace-brick if we find source brick offline even in the case of commit-force.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. Create a plain distribute volume of one brick.
2. Kill the brick process.
3. Now issue replace-brick start, followed by replace-brick commit-force.
  
Actual results:
Error message saying "Source brick is not online."

Expected results:
Replace-brick commit-force operation should succeed.

Additional info:
Comment 1 Anand Avati 2012-03-27 13:34:19 EDT
CHANGE: http://review.gluster.com/2620 (glusterd: Fixed replace-brick commit_force algo.) merged in master by Vijay Bellur (vijay@gluster.com)
Comment 2 shishir gowda 2012-05-29 07:05:39 EDT
gluster> volume create new sng:/export/dir1
Creation of volume new has been successful. Please start the volume to access data.
gluster> volume start new
Starting volume new has been successful


root@shishirng:~# kill -s 9 1511
root@shishirng:~# gluster

gluster> volume replace-brick new sng:/export/dir1 sng:/export/dir2 start
Source brick sng:/export/dir1 is not online.

gluster> volume replace-brick new sng:/export/dir1 sng:/export/dir2 commit force
replace-brick commit successful
gluster> volume info 
 
Volume Name: new
Type: Distribute
Volume ID: 17d10137-26a5-48d3-9bf1-c89b9ec42d0b
Status: Started
Number of Bricks: 1
Transport-type: tcp
Bricks:
Brick1: sng:/export/dir2
gluster>